defines.h File Reference
`#include "ruby/config.h"`
`#include <stddef.h>`

Go to the source code of this file.

## Macros

#define | RUBY
#define | _(args) ()
#define | __(args) ()
#define | ANYARGS
#define | xmalloc ruby_xmalloc
#define | xmalloc2 ruby_xmalloc2
#define | xcalloc ruby_xcalloc
#define | xrealloc ruby_xrealloc
#define | xrealloc2 ruby_xrealloc2
#define | xfree ruby_xfree
#define | STRINGIZE(expr) STRINGIZE0(expr)
#define | STRINGIZE0(expr) #expr
#define | BDIGIT unsigned int
#define | SIZEOF_BDIGITS SIZEOF_INT
#define | BDIGIT_DBL unsigned LONG_LONG
#define | BDIGIT_DBL_SIGNED LONG_LONG
#define | PRI_BDIGIT_PREFIX ""
#define | PRI_BDIGIT_DBL_PREFIX PRI_LL_PREFIX
#define | PRIdBDIGIT PRI_BDIGIT_PREFIX"d"
#define | PRIiBDIGIT PRI_BDIGIT_PREFIX"i"
#define | PRIoBDIGIT PRI_BDIGIT_PREFIX"o"
#define | PRIuBDIGIT PRI_BDIGIT_PREFIX"u"
#define | PRIxBDIGIT PRI_BDIGIT_PREFIX"x"
#define | PRIXBDIGIT PRI_BDIGIT_PREFIX"X"
#define | PRIdBDIGIT_DBL PRI_BDIGIT_DBL_PREFIX"d"
#define | PRIiBDIGIT_DBL PRI_BDIGIT_DBL_PREFIX"i"
#define | PRIoBDIGIT_DBL PRI_BDIGIT_DBL_PREFIX"o"
#define | PRIuBDIGIT_DBL PRI_BDIGIT_DBL_PREFIX"u"
#define | PRIxBDIGIT_DBL PRI_BDIGIT_DBL_PREFIX"x"
#define | PRIXBDIGIT_DBL PRI_BDIGIT_DBL_PREFIX"X"
#define | RUBY_FUNC_EXPORTED
#define | RUBY_EXTERN extern
#define | EXTERN RUBY_EXTERN /* deprecated */
#define | RUBY_MBCHAR_MAXSIZE INT_MAX
#define | FLUSH_REGISTER_WINDOWS ((void)0)
#define | PATH_SEP ":"
#define | PATH_SEP_CHAR PATH_SEP[0]
#define | PATH_ENV "PATH"
#define | CASEFOLD_FILESYSTEM 0
#define | DLEXT_MAXLEN 4
#define | RUBY_PLATFORM "unknown-unknown"
#define | RUBY_ALIAS_FUNCTION_TYPE(type, prot, name, args) type prot {return name args;}
#define | RUBY_ALIAS_FUNCTION_VOID(prot, name, args) void prot {name args;}
#define | RUBY_ALIAS_FUNCTION(prot, name, args) RUBY_ALIAS_FUNCTION_TYPE(VALUE, prot, name, args)

## Functions

void * | xmalloc (size_t)
void * | xmalloc2 (size_t, size_t)
void * | xcalloc (size_t, size_t)
void * | xrealloc (void *, size_t)
void * | xrealloc2 (void *, size_t, size_t)
void | xfree (void *)

## Macro Definition Documentation

#define _ | ( |  | args | ) | ()

Definition at line 44 of file defines.h.

#define __ | ( |  | args | ) | ()

Definition at line 51 of file defines.h.

#define ANYARGS

Definition at line 57 of file defines.h.

Referenced by copy_stream_fallback().

#define BDIGIT unsigned int

Definition at line 93 of file defines.h.

Referenced by bdigbitsize(), big2dbl(), big2str_orig(), big2ulong(), big_lshift(), big_real_len(), big_rshift(), big_split(), bigadd_core(), bigadd_int(), bigand_int(), BigDecimal_div(), BigDecimal_hash(), BigDecimal_memsize(), bigdivrem(), bigdivrem1(), bigfixize(), biglsh_bang(), bigmul1_balance(), bigmul1_karatsuba(), bigmul1_normal(), bigmul1_single(), bigmul1_toom3(), bignew_1(), bigor_int(), bigrsh_bang(), bigsqr_fast(), bigsub(), bigsub_int(), bigtrunc(), bigxor_int(), bigzero_p(), dbl2big(), get2comp(), int_pair_to_real_inclusive(), limited_big_rand(), make_seed_value(), memsize_of(), mt_state(), nlz(), r_object0(), random_load(), rb_big_and(), rb_big_aref(), rb_big_clone(), rb_big_cmp(), rb_big_eq(), rb_big_eql(), rb_big_hash(), rb_big_neg(), rb_big_or(), rb_big_pack(), rb_big_realloc(), rb_big_unpack(), rb_big_xor(), rb_cstr_to_inum(), rb_uint2big(), v2w(), VpAddAbs(), VpAddSub(), VpAlloc(), VpAsgn(), VpCtoV(), VpDivd(), VpDtoV(), VpDup(), VpLeftRound(), VpMidRound(), VpMult(), VpNmlz(), VpRdup(), VpSubAbs(), VpToFString(), VpToString(), and w_object().

#define BDIGIT_DBL unsigned LONG_LONG

Definition at line 95 of file defines.h.

Referenced by big2str_orig(), big2ulong(), big_lshift(), big_rshift(), bigadd_core(), bigadd_int(), bigand_int(), BigDecimal_div(), bigdivrem(), bigdivrem1(), bigmul1_normal(), bigmul1_single(), bigor_int(), bigsqr_fast(), bigxor_int(), get2comp(), rb_big_aref(), rb_cstr_to_inum(), rb_uint2big(), VpDivd(), VpMult(), and VpSzMantissa().

#define BDIGIT_DBL_SIGNED LONG_LONG

Definition at line 96 of file defines.h.

Referenced by BigDecimal_to_i(), bigdivrem1(), bigsub_core(), and bigsub_int().

#define CASEFOLD_FILESYSTEM 0

Definition at line 298 of file defines.h.

#define DLEXT_MAXLEN 4

Definition at line 303 of file defines.h.

Referenced by rb_feature_p().

#define EXTERN RUBY_EXTERN /* deprecated */

Definition at line 262 of file defines.h.

#define FLUSH_REGISTER_WINDOWS ((void)0)

Definition at line 278 of file defines.h.

Referenced by cont_restore_1(), cont_save_machine_stack(), mark_current_machine_context(), and rb_gc_save_machine_context().

#define PATH_ENV "PATH"

Definition at line 288 of file defines.h.

Referenced by dln_find_exe_r(), env_aset(), env_delete(), env_fetch(), process_options(), rb_env_path_tainted(), rb_f_getenv(), and ruby_init_loadpath_safe().

#define PATH_SEP ":"

Definition at line 284 of file defines.h.

Referenced by dln_find_1(), and Init_File().

#define PATH_SEP_CHAR PATH_SEP[0]

Definition at line 286 of file defines.h.

Referenced by push_include(), and rb_path_check().

#define PRI_BDIGIT_DBL_PREFIX PRI_LL_PREFIX

Definition at line 98 of file defines.h.

#define PRI_BDIGIT_PREFIX ""

Definition at line 97 of file defines.h.

#define PRIdBDIGIT PRI_BDIGIT_PREFIX"d"

Definition at line 122 of file defines.h.

#define PRIdBDIGIT_DBL PRI_BDIGIT_DBL_PREFIX"d"

Definition at line 129 of file defines.h.

#define PRIiBDIGIT PRI_BDIGIT_PREFIX"i"

Definition at line 123 of file defines.h.

#define PRIiBDIGIT_DBL PRI_BDIGIT_DBL_PREFIX"i"

Definition at line 130 of file defines.h.

#define PRIoBDIGIT PRI_BDIGIT_PREFIX"o"

Definition at line 124 of file defines.h.

#define PRIoBDIGIT_DBL PRI_BDIGIT_DBL_PREFIX"o"

Definition at line 131 of file defines.h.

#define PRIuBDIGIT PRI_BDIGIT_PREFIX"u"

Definition at line 125 of file defines.h.

#define PRIuBDIGIT_DBL PRI_BDIGIT_DBL_PREFIX"u"

Definition at line 132 of file defines.h.

#define PRIxBDIGIT PRI_BDIGIT_PREFIX"x"

Definition at line 126 of file defines.h.

#define PRIXBDIGIT PRI_BDIGIT_PREFIX"X"

Definition at line 127 of file defines.h.

#define PRIxBDIGIT_DBL PRI_BDIGIT_DBL_PREFIX"x"

Definition at line 133 of file defines.h.

#define PRIXBDIGIT_DBL PRI_BDIGIT_DBL_PREFIX"X"

Definition at line 134 of file defines.h.

#define RUBY

Definition at line 25 of file defines.h.

#define RUBY_ALIAS_FUNCTION | ( |  | prot,
|  |  | name,
|  |  | args
| ) |  | RUBY_ALIAS_FUNCTION_TYPE(VALUE, prot, name, args)

Definition at line 319 of file defines.h.

#define RUBY_ALIAS_FUNCTION_TYPE | ( |  | type,
|  |  | prot,
|  |  | name,
|  |  | args
| ) |  | type prot {return name args;}

Definition at line 311 of file defines.h.

#define RUBY_ALIAS_FUNCTION_VOID | ( |  | prot,
|  |  | name,
|  |  | args
| ) |  | void prot {name args;}

Definition at line 315 of file defines.h.

#define RUBY_EXTERN extern

Definition at line 258 of file defines.h.

Referenced by Init_dbm().

#define RUBY_FUNC_EXPORTED

Definition at line 254 of file defines.h.

#define RUBY_MBCHAR_MAXSIZE INT_MAX

Definition at line 266 of file defines.h.

#define RUBY_PLATFORM "unknown-unknown"

Definition at line 307 of file defines.h.

Referenced by Init_dl().

#define SIZEOF_BDIGITS SIZEOF_INT

Definition at line 94 of file defines.h.

Referenced by big2str_orig(), bigfixize(), check_shiftdown(), limited_big_rand(), make_seed_value(), mt_state(), r_object0(), rand_init(), random_load(), rb_big_pow(), rb_big_size(), rb_quad_pack(), rb_quad_unpack(), and w_object().

#define STRINGIZE | ( |  | expr | ) | STRINGIZE0(expr)

Definition at line 78 of file defines.h.

Referenced by long_toobig().

#define STRINGIZE0 | ( |  | expr | ) | #expr

Definition at line 80 of file defines.h.

#define xcalloc ruby_xcalloc

Definition at line 66 of file defines.h.

Referenced by function_call(), initialize(), rb_parser_calloc(), and start_document().

#define xfree ruby_xfree

Definition at line 69 of file defines.h.

#define xmalloc ruby_xmalloc

Definition at line 64 of file defines.h.

Referenced by allocate(), allocate_converted_string(), bbuf_clone(), date_strftime_alloc(), dlhandle_sym(), enc_register_at(), entry_repeat_range(), name_add(), new_code_range(), node_new(), node_new_backref(), node_new_cclass_by_codepoint_range(), onig_bbuf_init(), onig_new(), onig_new_with_source(), onig_region_new(), onig_region_resize(), onig_st_insert_strend(), parse_exp(), rb_digest_base_alloc(), rb_econv_add_transcoder_at(), rb_econv_insert_output(), rb_econv_set_replacement(), rb_group_member(), rb_parser_malloc(), rb_strftime_alloc(), rb_transcoding_open_by_transcoder(), resize_property_list(), ruby_getcwd(), ruby_strdup(), scan_env_add_mem_entry(), set_bm_backward_skip(), set_bm_skip(), set_optimize_exact_info(), stack_double(), str_dup(), strcat_capa(), strcat_capa_from_static(), strdup_with_null(), update_string_node_case_fold(), VpMemAlloc(), and zlib_mem_alloc().

#define xmalloc2 ruby_xmalloc2

Definition at line 65 of file defines.h.

#define xrealloc ruby_xrealloc

Definition at line 67 of file defines.h.

Referenced by allocate_converted_string(), dlhandle_sym(), entry_repeat_range(), extract_fd(), name_add(), onig_region_resize(), rb_econv_insert_output(), rb_parser_realloc(), rb_w32_fd_copy(), rb_w32_fd_dup(), rehash(), resize_property_list(), ruby_getcwd(), scan_env_add_mem_entry(), stack_double(), strcat_capa(), and update_string_node_case_fold().

#define xrealloc2 ruby_xrealloc2

Definition at line 68 of file defines.h.

## Function Documentation

void* xcalloc | ( | size_t | ,
|  | size_t |
| ) |  |

void xfree | ( | void * |  | ) |

Referenced by allocate_converted_string(), argf_free(), ary_resize_capa(), assign_heap_slot(), autoload_delete(), bbuf_free(), bm_free(), call_original_exit(), cbsubst_get_all_subst_keys(), cbsubst_get_subst_arg(), cbsubst_get_subst_key(), cbsubst_sym_to_subst(), clear_optimize_info(), date_strftime_alloc(), date_strftime_internal(), dealloc(), deallocate(), dir_free(), dir_s_chdir(), dispose_string(), dlcfunc_free(), dlhandle_sym(), dyna_pop_gen(), file_expand_path(), flo_to_s(), free_const_entry_i(), free_dbm(), free_dump_arg(), free_load_arg(), free_window(), function_call(), gzfile_free(), i_free_name_entry(), i_free_shared_class(), init_copy(), ip_free(), ip_ruby_cmd(), ip_ruby_cmd_receiver_get(), ip_ruby_eval(), ip_set_exc_message(), iseq_set_sequence(), lib_eventloop_ensure(), lib_fromUTF8_core(), lib_thread_callback(), lib_toUTF8_core(), load_unlock(), local_pop_gen(), name_add(), obj_free(), onig_compile(), onig_free(), onig_free_body(), onig_free_node_list(), onig_node_free(), onig_node_str_clear(), onig_region_free(), onig_region_resize(), onig_st_insert_strend(), output_hex_charref(), parser_free(), path_check_0(), proc_exec_v(), rand_init(), random_free(), rb_alias_variable(), rb_ary_free(), rb_ary_initialize(), rb_ary_replace(), rb_ary_sort_bang(), rb_big_realloc(), rb_const_remove(), rb_digest_base_alloc(), rb_dir_getwd(), rb_dlcfunc_initialize(), rb_econv_binmode(), rb_econv_close(), rb_econv_insert_output(), rb_econv_open0(), rb_econv_set_replacement(), rb_exec_end_proc(), rb_free_method_entry(), rb_gc_unregister_address(), rb_group_member(), rb_objspace_call_finalizer(), rb_parser_free(), rb_run_exec_options_err(), rb_stat_init(), rb_stat_init_copy(), rb_str_drop_bytes(), rb_str_free(), rb_str_resize(), rb_strftime_alloc(), rb_sweep_method_entry(), rb_thread_blocking_region_end(), rb_transcoding_close(), remove_defered_event_hook(), remove_event_hook(), remove_trace(), ruby_getcwd(), ruby_setenv(), run_exec_dup2(), start_document(), str_discard(), strftimev(), strio_free(), subst_free(), tcl_protect_core(), tcltklib_compile_info(), time_free(), time_strftime(), token_info_pop(), tr_trans(), transcode_search_path(), update_string_node_case_fold(), VpFree(), vtable_free(), w_float(), zlib_mem_free(), and zstream_free().

void* xmalloc | ( | size_t |  | ) |

void* xmalloc2 | ( | size_t | ,
|  | size_t |
| ) |  |

void* xrealloc | ( | void * | ,
|  | size_t |
| ) |  |

void* xrealloc2 | ( | void * | ,
|  | size_t | ,
|  | size_t |
| ) |  |